Cell asmCopyExpr(Cell e);

extern Name  nameHw;
extern Class classHw;
extern Cell  freeList;

Int asmNewInteger       = 0;
Int asmHistoryActive    = 0;
Int asmHistoryStart     = 0;
Int asmHistoryStop      = 0;
Int asmHistoryLevel     = 0;
Int used_steps          = 0;
Int result_is_evaluated = 0;
StackPtr sp_at_top      = asm_SP;
Int  evaluate_asm       = 1;


#include "dynfun.c"

primFun(primAsmEq) {
  // a -> a -> Bool
  Cell a = primArg(2);
  Cell b = primArg(1);

  if (a==b) updateRoot(nameTrue);
  else updateRoot(nameFalse);
}

primFun(primAsmSteps) {
  // IO Int
  Cell s = primArg(1);
  eval(s);
  updapRoot(ap(mkTuple(2),mkInt(used_steps)),s);
}


primFun(primAsmNewFun0) {
  // String -> Int -> (val -> val -> Bool) -> init -> AsmVar val
  Cell name              = primArg(4);
  Cell kind              = primArg(3);
  Cell eqFunction        = primArg(2);
  Cell initValue         = primArg(1);
  Int  save_evaluate_asm = evaluate_asm;
  Int  id;

  evaluate_asm = 1;
  initValue  = eval_value(initValue);
  eqFunction = strict_eval(eqFunction);
  eval(kind);
  id = DynamicFunction::create(name, 
			       (DynamicFunction::Kind_t)whnfInt, 
			       eqFunction,
			       initValue);

  evaluate_asm = save_evaluate_asm;
  updateRoot(ap(ASMFUN, id));
}

primFun(primAsmNewFun1) {
  // String -> Int -> val -> (key -> key -> Int) -> (val -> val -> Bool)
  //  -> [(key,val)] -> AsmVar (key -> val)

  Cell name             = primArg(6);
  Cell kind             = primArg(5);
  Cell defaultValue     = primArg(4);
  Cell ordFunction      = primArg(3);
  Cell eqFunction       = primArg(2);
  Cell assoc            = primArg(1);
  Int save_evaluate_asm = evaluate_asm;
  Int  id;

  evaluate_asm = 1;
  defaultValue = eval_value(defaultValue);

  eval(kind);
  id = DynamicFunction::create(name,
			       (DynamicFunction::Kind_t)whnfInt,
			       strict_eval(eqFunction),
			       strict_eval(ordFunction),
			       defaultValue,
			       assoc);
  evaluate_asm = save_evaluate_asm;
  updateRoot(ap(ASMFUN, id));
}

primFun(primAsmFire) {
  // IO () -> IO Bool
  Cell rule = primArg(2);
  Cell s    = primArg(1);
  if (asmHistoryActive) {
    eval(s);
    if (DynamicFunction::level()==0) DynamicFunction::updateState(false);
    if (asmHistoryLevel+asmHistoryStart<asmHistoryStop) {
      // restlichen Werte loeschen
      used_steps -= asmHistoryStop-(asmHistoryStart+asmHistoryLevel);
      asmHistoryStop = asmHistoryStart+asmHistoryLevel;
      DynamicFunction::resetState();
    }
    DynamicFunction::openFrame();
    asmHistoryLevel++;
    asmHistoryStop++;
    s = ap(nameSnd,ap(rule,s));
    eval(s);
    if (DynamicFunction::updateState(true)) {
      used_steps++;
      updapRoot(ap(mkTuple(2),nameTrue),s);
    }
    else {
      updapRoot(ap(mkTuple(2),nameFalse),s);
      DynamicFunction::closeFrame(false);
      asmHistoryLevel--;
      asmHistoryStop--;
    }
  }
  else {
    s = ap(nameSnd,ap(rule,s));
    eval(s);
    if (DynamicFunction::updateState(true)) {
      used_steps++;
      updapRoot(ap(mkTuple(2),nameTrue),s);
    }
    else 
      updapRoot(ap(mkTuple(2),nameFalse),s);
  }
  if (numberIndirects>100000) {
    garbageCollect();
    numberIndirects=0;
  }
}

primFun(primAsmShowHistory) {
  // Int -> IO Bool
  Cell i = primArg(2);
  Cell s = primArg(1);
  eval(s);
  eval(i);
  if (asmHistoryActive &&
      (whnfInt>=asmHistoryStart) &&
      (whnfInt<=asmHistoryStop)) {
    if (DynamicFunction::level()>asmHistoryStop-asmHistoryStart)
      internal("primAsmShowHistory not allowed in sub-machines");
    asmHistoryLevel = whnfInt-asmHistoryStart;
    updapRoot(ap(mkTuple(2),nameTrue),s);
  }
  else
    updapRoot(ap(mkTuple(2),nameFalse),s);
}

primFun(primAsmMinHistory) {
  // IO Int
  Cell s = primArg(1);
  eval(s);
  if (asmHistoryActive)
    updapRoot(ap(mkTuple(2),mkInt(asmHistoryStart)),s);
  else
    updapRoot(ap(mkTuple(2),mkInt(used_steps)),s);
}

primFun(primAsmCall) {
  // IO () -> IO ()
  Cell rule = primArg(2);
  Cell s    = primArg(1);
  if (DynamicFunction::consistent()) {
    DynamicFunction::openFrame();
    while (1) {
      s = ap(nameSnd,ap(rule,s));
      eval(s);
      if (!DynamicFunction::updateState(false)) break;
    }
    DynamicFunction::closeFrame(true);
  }
  updapRoot(ap(mkTuple(2),UNIT),s);
}

primFun(primAsmCall1) {
  // IO () -> IO Bool
  Cell rule = primArg(2);
  Cell s    = primArg(1);
  if (DynamicFunction::consistent()) {
    DynamicFunction::openFrame();
    s = ap(nameSnd,ap(rule,s));
    eval(s);
    if (DynamicFunction::updateState(false))
      updapRoot(ap(mkTuple(2),nameTrue),s);
    else
      updapRoot(ap(mkTuple(2),nameFalse),s);
    DynamicFunction::closeFrame(true);
  }
  else updapRoot(ap(mkTuple(2),nameFalse),s);
}

primFun(primAsmSCall1) {
  // IO () -> IO ()
  Cell rule = primArg(2);
  Cell s    = primArg(1);
  if (DynamicFunction::consistent()) {
    DynamicFunction::openSecureFrame();
    s = ap(nameSnd,ap(rule,s));
    eval(s);
    DynamicFunction::updateState(false);
    DynamicFunction::closeSecureFrame();
  }
  updapRoot(ap(mkTuple(2),UNIT),s);
}

primFun(primAsmSeq) {
  // IO () -> IO () -> IO ()
  Cell rule1 = primArg(3);
  Cell rule2 = primArg(2);
  Cell s     = primArg(1);
  DynamicFunction::openFrame();
  s = ap(nameSnd,ap(rule1,s));
  eval(s);
  DynamicFunction::updateState(false);
  s = ap(nameSnd,ap(rule2,s));
  eval(s);
  DynamicFunction::updateState(false);
  DynamicFunction::closeFrame(true);
  updapRoot(ap(mkTuple(2),UNIT),s);
}


primFun(primAsmWriteFun) {
  // AsmVar (key -> val) -> val -> IO ()
  Cell value  = primArg(2);
  Cell s      = primArg(1);
  eval(s);

  DynamicFunction *d = DynamicFunction::check(primArg(3));

  if (d->isInput()) {
      ERROR(0) "update of input function not allowed" ETHEN
      ERRTEXT "\n*** dynamic function : " ETHEN ERREXPR(d->funname());
      ERRTEXT "\n"
      EEND; 
  }

  d->write(value,false);
  updapRoot(ap(mkTuple(2),UNIT),s);
}

primFun(primAsmForceAssign) {
  // AsmVar (key -> val) -> val -> IO ()
  Cell value  = primArg(2);
  Cell s      = primArg(1);
  eval(s);

  DynamicFunction *d = DynamicFunction::check(primArg(3));

  if (d->isInput()) {
      ERROR(0) "update of input function not allowed" ETHEN
      ERRTEXT "\n*** dynamic function : " ETHEN ERREXPR(d->funname());
      ERRTEXT "\n"
      EEND; 
  }

  d->write(value,true);
  updapRoot(ap(mkTuple(2),UNIT),s);
}

primFun(primAsmSetHistory) {
  // Bool -> IO ()
  Cell b = primArg(2);
  Cell s = primArg(1);
  eval(s);
  eval(b);
  if ((whnfHead==nameTrue) && !asmHistoryActive) {
    if (DynamicFunction::level()!=0) 
      internal("asmSetHistory not allowed in submachines");
    asmHistoryActive = 1;
    asmHistoryStart  = used_steps;
    asmHistoryLevel  = 0;
    asmHistoryStop   = used_steps;
  }
  else if ((whnfHead==nameFalse) && asmHistoryActive) {
    used_steps -= asmHistoryStop-(asmHistoryStart+asmHistoryLevel);
    asmHistoryStop = asmHistoryStart+asmHistoryLevel;
    DynamicFunction::resetState();
    for (int i=0;i<asmHistoryLevel;i++) {
      DynamicFunction::closeFrame(true);
      DynamicFunction::updateState(false);
    }
    asmHistoryActive = 0;
    asmHistoryStop   = 0;
    asmHistoryStart  = 0;
  }
  updapRoot(ap(mkTuple(2),UNIT),s);
}

primFun(primAsmAssocsFun) {
  // AsmVar (arg -> value) -> [(arg,value)]
  DynamicFunction *d = DynamicFunction::check(primArg(1));

  if (d->isInput() || d->isOutput()) {
      ERROR(0) "assocs for input/output functions not defined" ETHEN
      ERRTEXT "\n*** dynamic function : " ETHEN ERREXPR(d->funname());
      ERRTEXT "\n"
      EEND; 
  }

  assert(d->supportsAssocs());
  updateRoot(d->getAssocs());
}

primFun(primAsmEmptyDom) {
  // AsmVar (arg -> value) -> Bool
  DynamicFunction *d = DynamicFunction::check(primArg(1));

  if (d->isInput() || d->isOutput()) {
      ERROR(0) "assocs for input/output functions not defined" ETHEN
      ERRTEXT "\n*** dynamic function : " ETHEN ERREXPR(d->funname());
      ERRTEXT "\n"
      EEND; 
  }

  assert(d->supportsAssocs());
  if (d->nonEmptyDom()) updateRoot(nameFalse);
  else updateRoot(nameTrue);
}

primFun(primAsmInDom) {
  // key -> AsmVar (key -> value) -> Bool
  Cell key    = primArg(2);

  DynamicFunction *d = DynamicFunction::check(primArg(1));

  if (d->isInput() || d->isOutput()) {
      ERROR(0) "inDom for input/output functions not defined" ETHEN
      ERRTEXT "\n*** dynamic function : " ETHEN ERREXPR(d->funname());
      ERRTEXT "\n"
      EEND; 
  }

  assert(d->supportsAssocs());
  if (d->inDom(key))
    updateRoot(nameTrue);
  else
    updateRoot(nameFalse);
}


primFun(primAsmRandom) {
  // Int -> Int
  Cell max = primArg(1);
  Int  res;

  eval(max);
  res = rand()%whnfInt;
   updateRoot(mkInt(res));
}

primFun(primAsmNewInteger) {
  // Int
  updatec(mkInt(asmNewInteger));
  asmNewInteger++;
}

primFun(primAsmSetInteger) {
  // Int -> IO ()
  Cell i = primArg(2);
  Cell s = primArg(1);

  eval(s);
  eval(i);
  asmNewInteger = whnfInt;
  updapRoot(ap(mkTuple(2),UNIT),s);
}

primFun(primAsmDefault) {
  // () -> a
  updateRoot(ASMDEFAULT);
}

primFun(primAsmStrictEval) {
  // a -> IO a
  Cell a = primArg(2);
  Cell s = primArg(1);
  Cell erg;

  eval(s);
  erg = strict_eval(a);
  updapRoot(ap(mkTuple(2),erg),s);
}

primFun(primAsmCopyExpr) {
  // a -> a
  Cell a = primArg(1);
  Cell old;

  heapListASM = NIL;
  a = asmCopyExpr(a);

  while (heapListASM!=NIL) {
    heapTopASM[fst(heapListASM)] = 0;
    old         = heapListASM;
    heapListASM = snd(heapListASM);
    snd(old)    = freeList;
    freeList    = old;
  }
  updatec(a);
}

primFun(primAsmDynFuns) {
  // IO [String]
  Cell s    = primArg(1);
  Name nm;
  eval(s);
  push(nameNil);
  for (nm=NAMEMIN; nm<nameHw; ++nm)
    if ((name(nm).asmvar_kind == ASM_DYNAMIC_FUNCTION) &&
	name(nm).asmvar_normal)
      top() = ap(ap(nameCons,
		    buildString(textToStr(name(nm).text))),top());
  updapRoot(ap(mkTuple(2),pop()),s);
}




Cell asmCopyExpr(Cell e)
{ 
  Cell x;
  if ((whatIs(e)==AP) && (fst(e)!=ASMFUN)) {
    if ((x = heapTopASM[e])) return x;
    heapListASM = ap(e,heapListASM);
    heapTopASM[e] = x = ap(NIL,NIL);
    fst(x) = asmCopyExpr(fst(e));
    snd(x) = asmCopyExpr(snd(e));
    return x;
  }
  else return e;
}

Cell strict_eval2(Cell e) 
{
  Int  args;
  Cell arg, res;

  result_is_evaluated = 0;
  eval(e);
  res = whnfHead;
  args = whnfArgs;
  if (result_is_evaluated) {
    while (args-->0) {
      arg = pop();
      res = ap(res,arg);
    }
  }
  else {
    while (args-->0) {
      arg = pop();
      res = ap(res,strict_eval2(arg));
    }
  }
  return res;
}


Void asmvar(Int what) {
  List l;
  Int  i;

  switch (what) {
  case RESET   :
    heapTopASM = heapASM + heapSize;
    evaluate_asm          = 1;
    sp_at_top             = asm_SP;
    last_evaluated_asmvar = NIL;
    DynamicFunction::resetState();
    break;
  case MARK  :
    mark(heapListASM);
    for (l=heapListASM;l!=NIL;l=snd(l))
      mark(heapTopASM[fst(l)]);
    DynamicFunction::removeUnusedFunctions();
    break;
  case INSTALL :
    used_steps    = 0;
    DynamicFunction::initClass();
    asmNewInteger = 0;
    heapASM       = heapAlloc(heapSize);
    
    if (heapASM==(Heap)0) {
      ERROR(0) "Cannot allocate heapASM storage (%d cells)",
	heapSize
	EEND;
    }
    for (i=0;i<heapSize;i++) heapASM[i]=0;
    heapTopASM = heapASM + heapSize;
    break;
 default:;
  }
}

INLINE Void asmPrintString(FILE *out, Cell e)
{
  eval(e);
  while (whnfHead==nameCons) {
    eval(pop());
    fputc(charOf(whnfHead),out);
    eval(pop());
  }
  fflush(out);
}

Cell asmReadFromStdin() {
  Int c = 0;
  Cell res = NIL, r = NIL;

  normalTerminal();
  do {
    if (c) {
      if (isNull(r)) {
	r   = ap(ap(nameCons,mkChar(c)),nameNil);
	res = r;
      }
      else {
	snd(r) = ap(ap(nameCons,mkChar(c)),nameNil);
	r      = snd(r);
      }
    }
    c = readTerminalChar();
  } while ((c!=EOF) && (c!='\n'));

  return isNull(res) ? nameNil : res;
}



Void used_funs(Cell e, List *res)
{
  if (isPair(e)) {
    used_funs(fst(e), res);
    used_funs(snd(e), res);
  }
  else if (whatIs(e)==NAME) 
    *res = ap(e, *res);
}


Void determineDynamic(Name nm)
{
  List l;
  if (name(nm).asmvar_kind!=ASM_NOTHING) return;
  if (name(nm).primDef) return;

  name(nm).asmvar_kind = ASM_STATIC;
  l = name(nm).used_funs;
  while (l!=NIL) {
    determineDynamic(fst(l));
    if ((name(fst(l)).asmvar_kind==ASM_DYNAMIC) 
	|| (name(fst(l)).asmvar_kind==ASM_DYNAMIC_FUNCTION)) {
      name(nm).asmvar_kind = ASM_DYNAMIC;
      //      printf("function %s is dynamic\n",textToStr(name(nm).text));
      name(nm).used_funs = NIL;
      return;
    }
    l = snd(l);
  }
  name(nm).used_funs = NIL;
}

Cell selectOfList(Int n, List l)
{
  while (n-->0) l = snd(l);
  return fst(l);
}

Void determineDynamicFunctions()
{
  Name  nm;
  Class c;
  List  l, l2;
  Int   i;
  

  for (c=CLASSMIN; c<classHw; c++) {
    l = class(c).defaults;
    for (i=0;l!=NIL;i++, l = snd(l))
      if (fst(l))
	used_funs(fst(l), 
		  &(name(selectOfList(i,class(c).members)).used_funs));

    l = class(c).instances;
    while (l!=NIL) {
      l2 = inst(fst(l)).implements;
      for (i=0;l2!=NIL;i++,l2=snd(l2))
	if (fst(l2))
	used_funs(fst(l2), 
		  &(name(selectOfList(i,class(c).members)).used_funs));
      l = snd(l);
    }
  }

  for (nm=NAMEMIN; nm<nameHw; ++nm) {
    if (nonNull(name(nm).type)) determineDynamic(nm);
    name(nm).used_funs = NIL;
  }
}
